
# katzepost_thinclient

*A thin client for sending and receiving messages via a Katzenpost mix network.*

This crate provides a thin client library for interacting with a
Katzenpost mixnet.

A mix network is a type of anonymous communications network.

A thin client library is code you can use as a depencency in your
application so that it can anonymously interact with services on the
mix network. The Katzenpost client daemon is a multiplexing client;
many applications on the same device can use their thin client
libraries to connect to the daemon and interact with mixnet services
concurrently.



## Contributions

This is a work in progress and we'll require feedback from developers to make improvements.
Pull requests welcome:

https://github.com/katzenpost/thin_client



## Documentation

* Rust API docs https://docs.rs/katzenpost_thin_client/0.0.4/katzenpost_thin_client/

* Katzenpost client integration guide https://github.com/katzenpost/website/blob/main/content/en/docs/client_integration.md



## 📦 Installation

Add katzenpost_thin_client to your `Cargo.toml`:

```toml
[dependencies]
rstructor = "0.0.4"
```


## Code Examples

* https://github.com/katzenpost/thin_client/blob/main/examples/echo_ping.rs


## Usage

To use this library you need to have a running Katzenpost client daemon.

Here's the client2 daemon source code:
https://github.com/katzenpost/katzenpost/tree/main/client2

That directory has a Makefile which will give you two ways to build the daemon:

1. Makefile target "warpedclientdaemon": build binary for use with docker test mixnet.
2. Makefile target "clientdaemon": build binary for production mixnet.

We recommend that you look over the client2.toml configuration file generated by
our dockerized test mixnet. Using that configuration file you can either make
the daemon listen for thin client connections on a TCP/IP socket or you can
specify a UNIX domain socket.



## Compatibility

Works with Katzenpost v0.0.40 or later.



## License

AGPLv3
